﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class EditFilmForm : Form
    {
        public EditFilmForm()
        {
            InitializeComponent();
        }
        private String cmd_string;
        private String fn = "";

        OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + "\\dbFilm.mdb");
        OleDbCommand cmd = new OleDbCommand();
        OleDbDataAdapter da = new OleDbDataAdapter();
        DataSet ds = new DataSet();

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult a = openFileDialog1.ShowDialog();
            if (a == DialogResult.OK)
            {
                fn = openFileDialog1.FileName;
                Image img = Image.FromFile(fn);
                pictureBox1.Image = (Image)img;
                pictureBox1.Refresh();
            }
        }

        private void EditFilmForm_Load(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "All picture files(*.gif;*.bmp;*.jpg)|*.gif;*.bmp;*.jpg";
            label4.Visible = false;
            textBox1.Text = GlobalClass.GlobalVar;

            cmd.Connection = con;
            cmd.CommandText = "select * from tblFilm Where cod_film=" + textBox1.Text;

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();

            da.SelectCommand = cmd;
            ds.Clear();
            da.Fill(ds, "tblFilm");

            textBox1.DataBindings.Add(new Binding("Text", ds, "tblFilm.cod_film"));
            textBox2.DataBindings.Add(new Binding("Text", ds, "tblFilm.name"));
            textBox3.DataBindings.Add(new Binding("Text", ds, "tblFilm.director"));
            textBox5.DataBindings.Add(new Binding("Text", ds, "tblFilm.writer"));
            textBox6.DataBindings.Add(new Binding("Text", ds, "tblFilm.actors"));
            textBox7.DataBindings.Add(new Binding("Text", ds, "tblFilm.country"));
            tempTextBox.DataBindings.Add(new Binding("Text", ds, "tblFilm.genre"));
            comboBox1.DataBindings.Add(new Binding("Text", ds, "tblFilm.lang"));
            textBox8.DataBindings.Add(new Binding("Text", ds, "tblFilm.y"));
            String genre = tempTextBox.Text;
            String[] genreList = genre.Split('-');
            for (int i = 0; i < genreList.Length; i++)
                for (int j = 0; j < checkedListBox1.Items.Count; j++)
                    if (genreList[i] == checkedListBox1.Items[j].ToString())
                        checkedListBox1.SetItemChecked(j, true);

            tempTextBox.Visible = false;
            textBox9.DataBindings.Add(new Binding("Text", ds, "tblFilm.summary"));
            label4.DataBindings.Add(new Binding("Text", ds, "tblFilm.poster"));

            String fn;
            if (label4.Text == "1")
                fn = Application.StartupPath + "\\Poster\\" + textBox1.Text + ".jpg";
            else
                fn = Application.StartupPath + "\\Poster\\addposter.jpg";

            FileStream s1 = new FileStream(fn, FileMode.Open, FileAccess.Read);
            pictureBox1.Image = (Image)new Bitmap(s1).Clone();
            s1.Close();
            s1.Dispose();

            //Image img = Image.FromFile(fn);
            //pictureBox1.Image = (Image)img;
            //pictureBox1.Refresh();

        }

        void doCmd(string cmd_string)
        {
            cmd.Connection = con;
            cmd.CommandType = CommandType.Text;
            cmd.CommandText = cmd_string;
            con.Open();
            int temp = cmd.ExecuteNonQuery();
            if (temp > 0)
            {
                Bitmap b = new Bitmap((Image)pictureBox1.Image.Clone());
                b.Save(Application.StartupPath + "\\poster\\" + textBox1.Text + ".jpg");
                //pictureBox1.Image.Save(Application.StartupPath + "\\poster\\" + textBox1.Text + ".jpg");
                MessageBox.Show("اطلاعات ثبت شد", "", MessageBoxButtons.OK, MessageBoxIcon.Information);

                //refresh DataGridView of ShowFilmForm
                ShowFilmForm form1 = (ShowFilmForm)Application.OpenForms["ShowFilmForm"];
                DataGridView dgv = (DataGridView)form1.Controls["dataGridView1"];
                cmd.CommandText = "select * from tblFilm";
                da.SelectCommand = cmd;
                ds.Clear();
                da.Fill(ds, "tblFilm");
                dgv.DataSource = ds.Tables[0].DefaultView;
            }
            else
                MessageBox.Show("بدلیل بروز خطا اطلاعات ثبت نشد", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            con.Close();
        }

        private bool RecExists(string cmd_string)
        {
            cmd.Connection = con;
            cmd.CommandType = CommandType.Text;
            cmd.CommandText = cmd_string;
            con.Open();
            OleDbDataReader r = cmd.ExecuteReader();
            bool flag = false;
            if (r.HasRows)
                flag = true;

            r.Close();
            con.Close();
            return flag;
        }
        private void saveBtn_Click(object sender, EventArgs e)
        {
            if (GlobalClass.GlobalVar != textBox1.Text)
            {
                cmd_string = "SELECT cod_film FROM tblFilm WHERE cod_film=" + textBox1.Text;
                if (RecExists(cmd_string))
                {
                    MessageBox.Show(".کد فیلم تکراری است.عملیات انجام نشد", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
            String genre = "";
            foreach (object itemChecked in checkedListBox1.CheckedItems)
                if (genre == "")
                    genre += itemChecked.ToString();
                else
                    genre += "-" + itemChecked.ToString();

            cmd_string = "Update tblFilm Set cod_film=@newcode, name=@name, director=@dire, writer=@writer, actors=@actors, genre=@genre, country=@cnry, y=@y, lang=@lang, summary=@smr WHERE cod_film=@oldcode";

            cmd.Parameters.Clear();
            cmd.Parameters.Add("@newcode", OleDbType.Integer);
            cmd.Parameters.Add("@name", OleDbType.Char);
            cmd.Parameters.Add("@dire", OleDbType.Char);
            cmd.Parameters.Add("@writer", OleDbType.Char);
            cmd.Parameters.Add("@actors", OleDbType.Char);
            cmd.Parameters.Add("@genre", OleDbType.Char);
            cmd.Parameters.Add("@cnry", OleDbType.Char);
            cmd.Parameters.Add("@y", OleDbType.Char);
            cmd.Parameters.Add("@lang", OleDbType.Char);
            cmd.Parameters.Add("@smr", OleDbType.Char);
            cmd.Parameters.Add("@oldcode", OleDbType.Integer);

            cmd.Parameters[0].Value = Convert.ToInt32(textBox1.Text);
            cmd.Parameters[1].Value = textBox2.Text;
            cmd.Parameters[2].Value = textBox3.Text;
            cmd.Parameters[3].Value = textBox5.Text;
            cmd.Parameters[4].Value = textBox6.Text;
            cmd.Parameters[5].Value = genre;
            cmd.Parameters[6].Value = textBox7.Text;
            cmd.Parameters[7].Value = textBox8.Text;
            cmd.Parameters[8].Value = comboBox1.Text;
            cmd.Parameters[9].Value = textBox9.Text;
            cmd.Parameters[10].Value = Convert.ToInt32(GlobalClass.GlobalVar);

            doCmd(cmd_string);

            this.Close();

        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }



    }
}
